#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include "vars.h"

 void init_antivir_plugin(void)
{

int in[2],out[2];
int pid;
char tmp[1024];

  if (pipe(in))
    {
      err_mes ("Can't make pipe in for antivir plugin\n");
      exit(-1);
    } 
  if (pipe(out))
    {
      err_mes ("Can't make pipe out for antivir plugin\n");
      exit(-1);
    } 

  pid=fork();
  if (pid<0) 
     {
      err_mes ("Can't fork for antivir plugin\n");
      exit(-1);
     }

  else if (pid==0)
   { //children
    close(out[0]);
    close(in[1]);

    dup2(in[0],STDIN_FILENO);
    dup2(out[1],STDOUT_FILENO);

    if (execlp(antivir_plugin,antivir_plugin,NULL)<0)
     {
      sprintf (tmp, "ERROR: Can't start antivir plugin(%s): %s\n",antivir_plugin, strerror(errno));
      err_mes(tmp);
      exit(-1);
     }

   }
   else
   {// parent
    close(in[0]);
    close(out[1]);
    
    if ((antivir_plugin_out=fdopen(in[1],"w"))==NULL)
    {
     err_mes("Can't fdopen out streem for antivir plugin\n");
     exit(-1);
    }
    if ((antivir_plugin_in=fdopen(out[0],"r"))==NULL)
    {
     err_mes("Can't fdopen input streem for antivir plugin\n");
     exit(-1);
    }
   }
}

char* ask_antivir_plugin(void)
{
 static char buf[1024];
 
 fprintf(antivir_plugin_out,"%s\n",input_url);
 fflush(antivir_plugin_out);
 fgets(buf,1023,antivir_plugin_in);
 buf[strlen(buf)-1]=0;
 return(buf);
}

