#define PAT_MAX 13
#define MAX 200
#include <stdio.h>
#include <errno.h>
#include <pcre.h>
#include <string.h>
#include "vars.h"


void get_opt(char* CONFIG)
{
 FILE *conf;
 pcre* pat[PAT_MAX];
 pcre_extra *spat[PAT_MAX];
 char pattern[PAT_MAX][100],etmp[MAX],tmp[MAX],*rez;

 const char *errstr; 
 int i,z,errchar,h_flag=0,vector[MAX],pairs,vecsize=MAX;
 #ifdef DEBUG_CFG
 int j;
 #endif
 
  /********** Set pattern ************************/
  sprintf(pattern[0],"^\\s*#");
  sprintf(pattern[1],"^\\s*error_log\\s+(\\S+)");
  sprintf(pattern[2],"^\\s*change_log\\s+(\\S+)");
  sprintf(pattern[3],"^\\s*\\<(\\S+)\\>");
  sprintf(pattern[4],"^\\s*ban_dir\\s+(\\S+)");
  sprintf(pattern[5],"^\\s*url\\s+(\\S+)");
  sprintf(pattern[6],"^\\s*allow_ip\\s+(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)[\\s\\#]");
  sprintf(pattern[7],"^\\s*allow_ip\\s+(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)\\/(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)");
  sprintf(pattern[8],"^\\s*allow_id\\s+(\\S+)");
  sprintf(pattern[9],"^\\s*allow_url\\s+(\\S+)");
  sprintf(pattern[10],"^\\s*log\\s+(\\S+)");
  sprintf(pattern[11],"^\\s*");
  sprintf(pattern[12],"^\\s*antivir_plugin\\s+(.+)$");

  /********* Init vars ***************/
  err_log=NULL;
  chg_log=NULL;
  antivir_plugin=NULL;

  allow_ip=NULL;
  allow_ip_count=0;
  
  allow_id=NULL;
  allow_id_count=0;
  
  allow_url=NULL;
  allow_url_count=0;

  redir=NULL;
  sections_count=0;  


/*********** Load patterns ************/
   for(i=0;i<PAT_MAX;i++)
   {
    /********* Compile pattern **************/
     if((pat[i]=pcre_compile(pattern[i],PCRE_CASELESS,&errstr,&errchar,NULL))==NULL)
        {
         sprintf(tmp,"ERROR: Can't compile pattern: i=%i %s\n%s\n",i,errstr,pattern[i]);
         printf("%s\n",tmp);
        exit(-1);
        }

    /******* Optimize patterns ***************/
     spat[i]=pcre_study(pat[i],0,&errstr);    
   }
/******** OPEN redirector.conf *****************/
if ((conf=fopen(CONFIG,"r"))==NULL)
       {
        sprintf(tmp,"ERROR: Can't open config file %s: %s\n",CONFIG,strerror(errno));
	printf("%s",tmp);
	printf("Use: redirector /path/to/redirector.conf\n");
	printf("by default: /usr/local/rejik2/redirector.conf\n\n");
        exit(-1);
       }
/************** Load vars from config *************/

while (!feof(conf))
{
    fgets(tmp,MAX,conf);


  // Comment "#"  
    pairs=pcre_exec(pat[0],spat[0],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
      continue;
      
  // error log  
    pairs=pcre_exec(pat[1],spat[1],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      err_log=strdup(rez);
      continue;
     }
   // change log  
    pairs=pcre_exec(pat[2],spat[2],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      chg_log=strdup(rez);
      continue;
     }

   // Antivirus plugin
    pairs=pcre_exec(pat[12],spat[12],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      antivir_plugin=strdup(rez);
      continue;
     }

   // First <HEADER>  
    pairs=pcre_exec(pat[3],spat[3],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(!h_flag && pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;

	//Add memory line
	redir=(struct section**)realloc(redir,(1+sections_count)*sizeof(struct section*));
	if (redir==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir struct\n");
	    exit(-1);
           }
	redir[sections_count]=(struct section*) malloc((1+sections_count) * sizeof(struct section));
	   if (redir[sections_count]==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir struct\n");
	    exit(-1);
           }
	memset(redir[sections_count],0,sizeof(struct section));
    //Set name of section
	redir[sections_count]->name=strdup(rez);
	 if (redir[sections_count]->name==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir->name\n");
	    exit(-1);
           }
      h_flag=1;
      continue;
     }

   // Next <HEADER>  
    if(h_flag && pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      sections_count++;
      
	//Add memory line
	redir=(struct section**)realloc(redir,(1+sections_count)*sizeof(struct section*));
	if (redir==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir struct\n");
	    exit(-1);
           }
	redir[sections_count]=(struct section*) malloc((1+sections_count) * sizeof(struct section));
	   if (redir[sections_count]==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir struct\n");
	    exit(-1);
           }
	memset(redir[sections_count],0,sizeof(struct section));
    //Set name of section
	redir[sections_count]->name=strdup(rez);
	 if (redir[sections_count]->name==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for redir->name\n");
	    exit(-1);
           }

      continue;     
     }

   // ban_dir
    pairs=pcre_exec(pat[4],spat[4],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(h_flag && pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;

      redir[sections_count]->ban_dir=strdup(rez);
      if (redir[sections_count]->ban_dir==NULL) 
          {
	    err_mes("Error: Can't allocate memory for redir->ban_dir\n");
	    exit(-1);
           }
      continue;
     }

   // url  
   
    pairs=pcre_exec(pat[5],spat[5],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(h_flag && pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      redir[sections_count]->url=strdup(rez);
      if (redir[sections_count]->url==NULL) 
          {
	    err_mes("Error: Can't allocate memory for redir->url\n");
	    exit(-1);
           }

      continue;
     }
  // log_flag
    pairs=pcre_exec(pat[10],spat[10],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(h_flag && pairs>=0)
     {
      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      if (strcmp(rez,"off")) redir[sections_count]->log_flag=0;
      else redir[sections_count]->log_flag=1;
      continue;
     }
   // allow_ip 127.0.0.1
    pairs=pcre_exec(pat[6],spat[6],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
      if (!h_flag) //for global ip_allow
       {
	//Add memory line
	allow_ip=(unsigned char**)realloc(allow_ip,(1+allow_ip_count)*sizeof(unsigned char*));
	if (allow_ip==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for global allow_ip\n");
	    exit(-1);
           }
	allow_ip[allow_ip_count]=(unsigned char*) malloc(8 * sizeof(unsigned char));
	   if (allow_ip[allow_ip_count]==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for global allow_ip\n");
	    exit(-1);
           }

        //127.
        rez=tmp+vector[2]; tmp[vector[3]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][0]=z;
        else { 
              sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	      err_mes(etmp);
	      exit(-1);
	     }
	//127.0.
        rez=tmp+vector[4]; tmp[vector[5]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][1]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//127.0.0.
        rez=tmp+vector[6]; tmp[vector[7]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][2]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//127.0.0.1
        rez=tmp+vector[8]; tmp[vector[9]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][3]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }
	//127.0.0.1/255.255.255.255
	allow_ip[allow_ip_count][4]=255;
	allow_ip[allow_ip_count][5]=255;
	allow_ip[allow_ip_count][6]=255;
	allow_ip[allow_ip_count][7]=255;
       
       allow_ip_count++;
	 }
       

    else // for section ip_allow
           {
	    //Add memory line
	    redir[sections_count]->allow_ip=(unsigned char**)realloc(redir[sections_count]->allow_ip,(1+redir[sections_count]->allow_ip_count)*sizeof(unsigned char*));
	if (redir[sections_count]->allow_ip==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_ip in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }
	redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count]=(unsigned char*) malloc(8 * sizeof(unsigned char));
	   if (redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count]==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_ip in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }

        //127.
        rez=tmp+vector[2]; tmp[vector[3]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][0]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }
	//127.0.
        rez=tmp+vector[4]; tmp[vector[5]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][1]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//127.0.0.
        rez=tmp+vector[6]; tmp[vector[7]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][2]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//127.0.0.1
        rez=tmp+vector[8]; tmp[vector[9]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][3]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }
	//127.0.0.1/255.255.255.255
	 redir[sections_count]->allow_ip[ redir[sections_count]->allow_ip_count][4]=255;
	 redir[sections_count]->allow_ip[ redir[sections_count]->allow_ip_count][5]=255;
	 redir[sections_count]->allow_ip[ redir[sections_count]->allow_ip_count][6]=255;
	 redir[sections_count]->allow_ip[ redir[sections_count]->allow_ip_count][7]=255;
       
       redir[sections_count]->allow_ip_count++;
       } //else
       continue;
       } //if pcre

   // allow_ip 192.168.0.1/255.255.0.0
    pairs=pcre_exec(pat[7],spat[7],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
      if (!h_flag) //for global ip_allow
       {
	//Add memory line
	allow_ip=(unsigned char**)realloc(allow_ip,(1+allow_ip_count)*sizeof(unsigned char*));
	   if (allow_ip==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for global allow_ip w mask\n");
	    exit(-1);
           }
	allow_ip[allow_ip_count]=(unsigned char*) malloc(8 * sizeof(unsigned char));
	   if (allow_ip[allow_ip_count]==NULL) 
	   {
	    err_mes("Error: Can't allocate memoryfor global allow_ip w mask\n");
	    exit(-1);
           }

        //192.
        rez=tmp+vector[2]; tmp[vector[3]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][0]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }
	//192.168.
        rez=tmp+vector[4]; tmp[vector[5]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][1]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.
        rez=tmp+vector[6]; tmp[vector[7]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][2]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1
        rez=tmp+vector[8]; tmp[vector[9]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][3]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }
	//192.168.0.1/255.
        rez=tmp+vector[10]; tmp[vector[11]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][4]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.
        rez=tmp+vector[12]; tmp[vector[13]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][5]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.0.
        rez=tmp+vector[14]; tmp[vector[15]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][6]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.0.0
        rez=tmp+vector[16]; tmp[vector[17]]=0; z=atoi(rez);
        if (z>=0 && z<=255) allow_ip[allow_ip_count][7]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for global ip_allow:%s",rez);
	    err_mes(etmp);
	    exit(-1);
	   }

       allow_ip_count++;
       } // if

    else // for section ip_allow
           {
	    //Add memory line
	    redir[sections_count]->allow_ip=(unsigned char**)realloc(redir[sections_count]->allow_ip,(1+redir[sections_count]->allow_ip_count)*sizeof(unsigned char*));
	   if (redir[sections_count]->allow_ip==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_ip in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }
	   redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count]=(unsigned char*) malloc(8 * sizeof(unsigned char));
	   if (redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count]==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_ip in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }


        //192.
        rez=tmp+vector[2]; tmp[vector[3]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][0]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }
	//192.168.
        rez=tmp+vector[4]; tmp[vector[5]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][1]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.
        rez=tmp+vector[6]; tmp[vector[7]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][2]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1
        rez=tmp+vector[8]; tmp[vector[9]]=0; z=atoi(rez);

        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][3]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.
        rez=tmp+vector[10]; tmp[vector[11]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][4]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.
        rez=tmp+vector[12]; tmp[vector[13]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][5]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.0.
        rez=tmp+vector[14]; tmp[vector[15]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][6]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

	//192.168.0.1/255.255.0.0
        rez=tmp+vector[16]; tmp[vector[17]]=0; z=atoi(rez);
        if (z>=0 && z<=255) redir[sections_count]->allow_ip[redir[sections_count]->allow_ip_count][7]=z;
        else { 
            sprintf(etmp,"Error in config file. Bad argument for ip_allow:%s in secrion: %s",rez,redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
	   }

       redir[sections_count]->allow_ip_count++;
       } // else
      continue;

     } // if pcre

   // allow_id
    pairs=pcre_exec(pat[8],spat[8],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
     if (!h_flag) // global
     {
     //Add memory line
     allow_id=(unsigned char**)realloc(allow_id,(1+allow_id_count)*sizeof(unsigned char*));
	   if (allow_id==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for allow_id\n");
	    exit(-1);
           }

      rez=tmp+vector[2];
      tmp[vector[3]]=0;
      allow_id[allow_id_count]=(unsigned char*)strdup(rez);
	   if (allow_id[allow_id_count]==NULL) 
	   {
	    err_mes("Error: Can't allocate memory for allow_id\n");
	    exit(-1);
           }
     allow_id_count++;
      continue;
     }
    else //section
     {
     //Add memory line
     redir[sections_count]->allow_id=(unsigned char**)realloc(redir[sections_count]->allow_id,(1+redir[sections_count]->allow_id_count)*sizeof(unsigned char*));
	   if (redir[sections_count]->allow_id==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_id in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }

      rez=tmp+vector[2];
      tmp[vector[3]]=0;

      redir[sections_count]->allow_id[redir[sections_count]->allow_id_count]=strdup(rez);
	   if (redir[sections_count]->allow_id[redir[sections_count]->allow_id_count]==NULL) 
	   {
	    sprintf(etmp,"Error: Can't allocate memory for allow_id in section %s\n",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
           }
      redir[sections_count]->allow_id_count++;
      continue;
     }//else
 } //if pcre




   // allow_url 
    pairs=pcre_exec(pat[9],spat[9],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
     {
     if (!h_flag) // global
     {
      //Add memory line
      allow_url=(unsigned char**)realloc(allow_url,(1+allow_url_count)*sizeof(unsigned char*));
      if (allow_url==NULL) 
      {
       err_mes("Error: Can't allocate memory for allow_url\n");
       exit(-1);
      }

      rez=tmp+vector[2];
      tmp[vector[3]]=0;

     allow_url[allow_url_count]=strdup(rez);
      if (allow_url[allow_url_count]==NULL) 
      {
       err_mes("Error: Can't allocate memory for allow_url\n");
       exit(-1);
      }
      allow_url_count++;
      continue;
     }
    else //section
     {
	    sprintf(etmp,"Error in config file in %s section: allow_url may be use only global section.",redir[sections_count]->name);
	    err_mes(etmp);
	    exit(-1);
     }//else
  } //if pcre

    // empty line
    pairs=pcre_exec(pat[11],spat[11],tmp,strlen(tmp),0,PCRE_NOTEMPTY,vector,vecsize);
    if(pairs>=0)
    continue;
    

    //Understand options
    sprintf(etmp,"WARNING! Understand option in config file: %s ... Ignoring",tmp);
	    err_mes(etmp);
} //while
fclose(conf);    
sections_count+=h_flag;

/********** Set log flag *************************/

if (!chg_log)
for (z=0;z<sections_count; z++)
redir[z]->log_flag=1;

/********** Check for error in config file *******/

for (z=0;z<sections_count; z++)
{
 if (redir[z]->name==NULL)
       {
	sprintf(etmp,"Error interpretation <HEADER> in config file");
	err_mes(etmp);
	exit(-1);
       }
 if (redir[z]->ban_dir==NULL)
       {
	sprintf(etmp,"Error in config file: not found ban_dir option for %s",redir[z]->name);
	err_mes(etmp);
	exit(-1);
       }
 if (redir[z]->url==NULL)
       {
	sprintf(etmp,"Error in config file: not found url option for %s",redir[z]->name);
	err_mes(etmp);
	exit(-1);
       }
}

/********* Convert ip/mask to network/mask *********/
    //for global
    for (z=0;z<allow_ip_count;z++)
    { 
     allow_ip[z][0]&=allow_ip[z][4];
     allow_ip[z][1]&=allow_ip[z][5];
     allow_ip[z][2]&=allow_ip[z][6];
     allow_ip[z][3]&=allow_ip[z][7];
    }
    
    //for sections
    for(i=0;i<sections_count;i++)
    for (z=0;z<redir[i]->allow_ip_count;z++)
    { 
     redir[i]->allow_ip[z][0]&=redir[i]->allow_ip[z][4];
     redir[i]->allow_ip[z][1]&=redir[i]->allow_ip[z][5];
     redir[i]->allow_ip[z][2]&=redir[i]->allow_ip[z][6];
     redir[i]->allow_ip[z][3]&=redir[i]->allow_ip[z][7];
    }


#ifdef DEBUG_CFG
printf("\n========== GLOBAL ===========\n");
if (err_log)  printf(" error log:%s\n",err_log);
else printf(" error log: none\n");

if (chg_log)  printf("change log:%s\n",chg_log);
else printf("change log: none\n");

if (antivir_plugin)  printf("antivir plugin: %s\n",antivir_plugin);
else printf("antivir plugin: none\n");

printf("Allow_ip_count: %i\n",allow_ip_count);
     for(j=0;j<allow_ip_count;j++)
     {
       printf("  allow-ip: %i.%i.%i.%i/%i.%i.%i.%i\n",allow_ip[j][0],allow_ip[j][1],allow_ip[j][2],allow_ip[j][3],allow_ip[j][4],allow_ip[j][5],allow_ip[j][6],allow_ip[j][7]);
     }

printf("Allow_id_count: %i\n",allow_id_count);
     for(j=0;j<allow_id_count;j++)
     {
       printf("  allow-id: %s\n",allow_id[j]);
     }

printf("Allow_url_count: %i\n",allow_url_count);
     for(j=0;j<allow_url_count;j++)
     {
       printf("  allow-url: %s\n",allow_url[j]);
     }


printf("Redir counter: %i\n",sections_count);

    for (z=0;z<sections_count; z++)
    {
     printf ("===========================\n");
     printf ("Name: %s\n",redir[z]->name);
     printf ("       Dir: %s\n",redir[z]->ban_dir);
     printf ("       URL: %s\n",redir[z]->url);
     printf ("  Log_flag: %i (0-on,1-off)\n",redir[z]->log_flag);


printf("Allow_ip_count: %i\n",redir[z]->allow_ip_count);
     for(j=0;j<redir[z]->allow_ip_count;j++)
     {
       printf("  allow-ip: %i.%i.%i.%i/%i.%i.%i.%i\n",redir[z]->allow_ip[j][0],redir[z]->allow_ip[j][1],redir[z]->allow_ip[j][2],redir[z]->allow_ip[j][3],redir[z]->allow_ip[j][4],redir[z]->allow_ip[j][5],redir[z]->allow_ip[j][6],redir[z]->allow_ip[j][7]);
     }
printf("Allow_id_count: %i\n",redir[z]->allow_id_count);
     for(j=0;j<redir[z]->allow_id_count;j++)
     {
       printf("  allow-id: %s\n",redir[z]->allow_id[j]);
     }
    }


#endif
}
