#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "vars.h"


/***************************************
 ********** Start MAIN function ********/
 int main(int argc, char* argv[])
{

 int z;
// int z,flag,i,k;
 unsigned char tmp[200],str[8192];//,*separator;
 int flag;	 


    //Load config file
    if (argc!=2) {get_opt("/usr/local/rejik2/redirector.conf");}
    else {get_opt(argv[1]);}

    //Init some vars
    init_vars();

    //Init antivir plugin
    if (antivir_plugin) {init_antivir_plugin();}


    // sort global allow_id
    if(allow_id_count>0)
    sort_id(allow_id,allow_id_count);

    if(allow_url_count>0)
    prepare_allow_url();

    // Prepare section data
    for (z=0;z<sections_count; z++)
	{
	 // Load ban lists
	 load_urls_file(z);
	 // Load pcre lists
	 load_pcre_file(z);

	 //sort id_lists
	 if(redir[z]->allow_id_count>0)
	 sort_id(redir[z]->allow_id,redir[z]->allow_id_count);
	}

      

    //Open log file
    if (chg_log)
    for (z=0;z<sections_count; z++)
     {
       if (!redir[z]->log_flag)
        {
	    if ((log=fopen(chg_log,"a"))==NULL)
    	    {
             sprintf(tmp,"ERROR: Can't make chg_log file %s: %s\n",chg_log,strerror(errno));
             printf(tmp);
	     exit(-1);
    	    }

	#ifdef DEBUG_CYCLE
	 printf ("\nOpen log file: %s\n",chg_log);
	#endif
	break;
	}
     }
err_mes("Redirector start and working");
			       
/***********************
 ****** Work cycle *****/        
    // Get input string
    while (fgets(str,8192,stdin)!=NULL)
    {   
        // convert input string to input structure->(url,who,ident,method)
        if(parse_input(str)) 
	   {
	    // If error in convert
	    printf ("%s",str); 
	    fflush(stdout);    	    
	    sprintf(tmp,"Error convert input string to input structure str=%s",str);
	    err_mes(tmp);
	    continue;
	   };
  /***** Check global allow *****/
	  if (allow_id_count && check_id(allow_id,allow_id_count)) 
	   {
	    #ifdef DEBUG_CYCLE
	    printf (" -->Skiping by allow_id in global section\n");
	    #endif
	    printf("%s",str);
	    fflush(stdout);    	    
	    continue;
	   }
	  if (allow_ip_count && check_ip(allow_ip,allow_ip_count)) 
	   {
	    #ifdef DEBUG_CYCLE
	    printf (" -->Skiping by allow_ip in global section\n");
	    #endif
	    printf("%s",str);
	    fflush(stdout);    	    
	    continue;
	   }
	  if (allow_url_count && check_allow_url()) 
	   {
	    #ifdef DEBUG_CYCLE
	    printf (" -->Skiping by allow_url in global section\n");
	    #endif
	    printf("%s",str);
	    fflush(stdout);    	    
	    continue;
	   }

    flag=0;

  /***** Check sections rules *****/
    for (z=0;z<sections_count; z++)
    {
    
    //Check for allow
	  if (redir[z]->allow_id_count && check_id(redir[z]->allow_id,redir[z]->allow_id_count)) 
	   {
	    #ifdef DEBUG_CYCLE
	    printf (" -->Skiping by allow_id in \"%s\" section\n",redir[z]->name);
	    #endif
	    continue;
	   }

	  if (redir[z]->allow_ip_count && check_ip(redir[z]->allow_ip,redir[z]->allow_ip_count)) 
	   {
	    #ifdef DEBUG_CYCLE
	    printf (" -->Skiping by allow_ip in \"%s\" section\n",redir[z]->name);
	    #endif
	    continue;
	   }

      //Check for BAN URLS
       flag=check_url(z);

       if (flag)
          {
	   printf("%s %d.%d.%d.%d/%s %s %s\n",redir[z]->url,input_ip[0],input_ip[1],input_ip[2],input_ip[3],input_host,input_ident,input_method);
	   fflush(stdout);

         
	   break;
	 }
    else 
    {

      //Check for BAN PCRE
       flag=check_pcre(z);
       if (flag)
          {
	   printf("%s %d.%d.%d.%d/%s %s %s\n",redir[z]->url,input_ip[0],input_ip[1],input_ip[2],input_ip[3],input_host,input_ident,input_method);
	   fflush(stdout);

	   break;
	 }

    }
    }// sections rules 

    if (!flag)
    {
     if (antivir_plugin)
      printf("%s %d.%d.%d.%d/%s %s %s\n",ask_antivir_plugin(),input_ip[0],input_ip[1],input_ip[2],input_ip[3],input_host,input_ident,input_method);
     else  
      printf("%s",str);

     fflush(stdout);    
    }

	#ifdef DEBUG_CYCLE
       if(!flag)
       {
	printf("\n===========\n");
	printf("str\t:%s",str);
	printf("url\t:%s:\n",input_url);
	printf("separator\t%d\n",input_separator);
	printf("ip\t:%d.%d.%d.%d:\n",input_ip[0],input_ip[1],input_ip[2],input_ip[3]);
	printf("host\t:%s:\n",input_host);
	printf("ident\t:%s:\n",input_ident);
	printf("method\t:%s:\n\n",input_method);	
       }
	#endif
    }//work cycle

 exit(0);
}
