#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "vars.h"

#define MAX 512
int cmp_u(const void *arg1, const void *arg2)
{
 int z;
 char *s1,*s2;
 s1=(char*)arg1+input_separator;
 s2=(char*)arg2;

 #ifdef DEBUG_URLS_CMP
 printf("cmp_url: %s(sep:%d) %s\n",arg1,input_separator,arg2);
 #endif

// Check before separator 
 for(z=0;*s2!='/' && *s2!=0 && *s1!='/';z++)
   {
    #ifdef DEBUG_URLS_CMP
	 if (*s1==*s2) printf("cmp: %c = %c\n",*s1,*s2);
	 else if(*s1>*s2)  printf("cmp: %c > %c\n",*s1,*s2);
	 else printf("cmp: %c < %c\n",*s1,*s2);
    #endif
//    if (*s1=='.' && *s2=='/') {return (1); }
//    if (*s1=='/' && *s2=='.') {return (-1); }
    if (*s1==*s2) {s1--;s2++; }
    else if(*s1>*s2) return (1);
    else return (-1);
   }

//start word found?
 #ifdef DEBUG_URLS_CMP
 printf("Start word? symbol before:%c:%c:\n",*s1,*s2);
 if  ((*s1!='.' &&  *s1!='/') || (*s2!=0 && *s2!='/'))
 printf ("No\n");
 else printf ("Yes\n");
 #endif
 if ((*s1!='.' &&  *s1!='/') || (*s2!=0 && *s2!='/')) 
 {
   if(*s1>*s2) return (1);
   else return (-1);
 }

//Check after separator
 if (*s2=='/')
  {
   s1=(char*)arg1+input_separator+1;
   
     for(z=0;*s2!=0;z++)
	{
	 #ifdef DEBUG_URLS_CMP
	 if (*s1==*s2) printf("cmp: %c = %c\n",*s1,*s2);
	 else if(*s1>*s2)  printf("cmp: %c > %c\n",*s1,*s2);
	 else printf("cmp: %c < %c\n",*s1,*s2);
	 #endif
	 if (*s1==*s2) {s1++;s2++;}
	 else if(*s1>*s2) return (1);
	 else return (-1);
	}
  }
 
//End word found?
 #ifdef DEBUG_URLS_CMP
 printf("end word? symbol after:%c:%c:\n",*s1,*s2);
 #endif
 if (*s1<43 || *s1>122 || *s1=='.' || *s1=='/' || *s1==96 || (*s1>57 && *s1<61) || (*s1>61 && *s1<65) ||  (*s1>90 && *s1<95)) return (0);
  {
   if(*s1>*s2) return (1);
   else return (-1);
  }
}


int domen_level(unsigned char **string)
{
 unsigned int z,k,count=1;
 unsigned char url[MAX],*separator;
 
 memcpy(url,*string,strlen(*string)+1);

    //find '/'
    separator=(unsigned char*)strchr(url,'/');
    if (separator) k=(unsigned char*)separator-(unsigned char*)url;
    else           k=strlen(url);
    
    for(z=0;z<k;z++)
    if (url[z]=='.') count++;

//    printf("%s dom=%d\n",url,count);    
    return(count);

}

int domen_level2(unsigned char *url)
{
 unsigned int z,k,count=1;
 unsigned char *separator;
 

    //find '/'
    separator=(unsigned char*)strchr(url,'/');
    if (separator) k=(unsigned char*)separator-(unsigned char*)url;
    else           k=strlen(url);
    
    for(z=0;z<k;z++)
    if (url[z]=='.') count++;

//    printf("%s dom2=%d\n",url,count);    
    return(count);

}

int cmp_domen(const void *arg1,const void *arg2)
{
 return(domen_level((unsigned char **)arg2)-domen_level((unsigned char **)arg1));
}

int cmp_urls(const void *arg1,const void *arg2)
{
    void **a1=(void **)arg1,**a2=(void **)arg2;
//    printf("cmp: %s %s\n",*a1,*a2);
    return(strcmp(*a1, *a2));
	 
}



int cmp_urls_find(const void *arg1,const void *arg2)
{
  void **a1=(void **)arg1,**a2=(void **)arg2;
  return(cmp_u(*a1, *a2));
}

/************************************
 ********* Load urls file ***********/
void load_urls_file(int section)
{
    FILE *fp;
    char tmp[MAX];
//    const char *errstr; 
//    unsigned int errchar; 
    unsigned int i,c,last=0;
    #ifdef DEBUG_URLS
    int j;
    #endif

    //Set pointer
    redir[section]->ban_urls=NULL;
    redir[section]->ban_urls_start=NULL;
    redir[section]->ban_urls_count=NULL;
    redir[section]->ban_urls_end=0;

    // Load urls file
    sprintf(tmp,"%s/urls",redir[section]->ban_dir);

    #ifdef DEBUG_URLS
    printf("=== %s ===\n",tmp);
    #endif

    if ((fp=fopen(tmp,"r"))==NULL)
	{ //No file
          sprintf(tmp,"WARNING: Can't open file %s/urls: %s",redir[section]->ban_dir,strerror(errno));
          err_mes(tmp);

	  #ifdef DEBUG_PCRE
//          printf("%s\n",tmp);
	  #endif

        }
    else
    {
     while(!feof(fp))
      {
        //Get
        if (fgets(tmp,MAX,fp)!=NULL)
        {
    	    //Chomp
    	    if (tmp[strlen(tmp)-1]=='\n') tmp[strlen(tmp)-1]=0;
	    if (strlen(tmp)>0)
	      {

    		#ifdef DEBUG_URLS
    		printf("urls: %s\n",tmp);
    		#endif

        	//Add memory line
        	redir[section]->ban_urls=(unsigned char **)realloc(redir[section]->ban_urls,(1+last)*sizeof(unsigned char *));
        	redir[section]->ban_urls[last]=(unsigned char*)strdup(tmp);
    
           	if (redir[section]->ban_urls==NULL || redir[section]->ban_urls[last]==NULL)
                {
                 err_mes("Error: Can't allocate memory for urls\n");
                 exit(-1);
                }


		last++;

	      }//if(strlen(tmp)>0)
       }//if fgets
     }//while

    fclose(fp);

    sprintf(tmp,"Load %i rules from %s/urls",last,redir[section]->ban_dir);
    err_mes(tmp);
   }// if fopen
   
   
if(last)
{

  //reverse urls
  reverse(redir[section]->ban_urls,last);


  //sort by domen level
  qsort(redir[section]->ban_urls,last,sizeof(unsigned char*),cmp_domen);

  #ifdef DEBUG_URLS
  for (i=0;i<last;i++)
  printf("reverse urls sort by domen: %s\n",redir[section]->ban_urls[i]);
  #endif


  //Set pointers and counter to domen sections    
  c=99999;
  
  for (i=0;i<last;i++)
  {
   if (domen_level2(redir[section]->ban_urls[i])!=c)
   {
    c=domen_level2(redir[section]->ban_urls[i]);
    
    redir[section]->ban_urls_start=(unsigned int *)realloc(redir[section]->ban_urls_start,(1+ redir[section]->ban_urls_end)*sizeof(unsigned int));
    redir[section]->ban_urls_count=(unsigned int *)realloc(redir[section]->ban_urls_count,(1+ redir[section]->ban_urls_end)*sizeof(unsigned int));
    
    if (redir[section]->ban_urls_start==NULL || redir[section]->ban_urls_count==NULL)
    {
     err_mes("Error: Can't allocate memory for urls\n");
     exit(-1);
    }
    redir[section]->ban_urls_start[redir[section]->ban_urls_end]=i;
    redir[section]->ban_urls_count[redir[section]->ban_urls_end]=1;
    redir[section]->ban_urls_end++;
   }
   else 
   {
     redir[section]->ban_urls_count[redir[section]->ban_urls_end-1]++;
   }
   
  } //for


  //sort domen section by name
  for(i=0;i<redir[section]->ban_urls_end;i++)
  qsort(&redir[section]->ban_urls[redir[section]->ban_urls_start[i]],redir[section]->ban_urls_count[i],sizeof(unsigned char*),cmp_urls);


  #ifdef DEBUG_URLS
  for(i=0;i<redir[section]->ban_urls_end;i++)
  {
   printf("======%d=====\n",i);
   
   for(j=0;j<redir[section]->ban_urls_count[i];j++)
   printf("%s\n",redir[section]->ban_urls[redir[section]->ban_urls_start[i]+j]);
  }
  #endif
  
}//if last
}


/******************************************
 ******** Check url by urls rules *********/
 unsigned int check_url(int section)
 {
  unsigned int i;
  unsigned char *ret;
  

  #ifdef DEBUG_URLS
  printf("Find %s in \"%s\" section\n",input_url,redir[section]->name);
  #endif
  
  for(i=0;i<redir[section]->ban_urls_end;i++)
  {
   ret=bsearch(&input_url,&redir[section]->ban_urls[redir[section]->ban_urls_start[i]],redir[section]->ban_urls_count[i],sizeof(unsigned char*),cmp_urls_find);

   if(ret)
    {
      if(!redir[section]->log_flag)
	{
//	 fprintf(log,"%s %s %d.%d.%d.%d/%s %s -> %s (file:%s/urls revers rule:%s)\n",now(),redir[section]->name,input_ip[0],input_ip[1],input_ip[2],input_ip[3],input_ident,input_url,redir[section]->url,redir[section]->ban_dir,redir[section]->ban_urls[((unsigned char *)ret-(unsigned char*)redir[section]->ban_urls)/sizeof(unsigned char*)]);
	 fprintf(log,"%s %s %d.%d.%d.%d/%s %s (file:%s/urls revers rule:%s)\n",now(),redir[section]->name,input_ip[0],input_ip[1],input_ip[2],input_ip[3],input_ident,input_url,redir[section]->ban_dir,redir[section]->ban_urls[((unsigned char *)ret-(unsigned char*)redir[section]->ban_urls)/sizeof(unsigned char*)]);
	 fflush (log);
	}
     //printf("%s\n",redir[section]->ban_urls[((unsigned char *)ret-(unsigned char*)redir[section]->ban_urls)/sizeof(unsigned char*)]);
    return(1);
//     return(1+((unsigned char *)ret-(unsigned char*)redir[section]->ban_urls)/sizeof(unsigned char*));
    }
  }
  return(0);
 }
 


