#include <stdlib.h>
#include <stdio.h>
#include <pcre.h>

/*** Print debug info for develop ***/
//#define DEBUG_CFG 1 
//#define DEBUG_LISTS 1
//#define DEBUG_CYCLE 1
//#define DEBUG_PCRE 1
//#define DEBUG_URLS 1
//#define DEBUG_URLS_CMP 1

FILE *log;

unsigned char *input_ident;
unsigned char *input_ip;
unsigned char *input_url;
unsigned char *input_method;
unsigned char *input_host;
unsigned int input_separator;

//GLOBAL OPTIONS
unsigned char *err_log;  //Error log path
unsigned char *chg_log;  //Change log path

unsigned char *antivir_plugin; // Antivirus plugin command
FILE *antivir_plugin_in,*antivir_plugin_out;

unsigned char **allow_ip; 	//Allow ip
unsigned int  allow_ip_count;  	//Allow ip count

unsigned char **allow_id;	//Allow id
unsigned int  allow_id_count;	//Allow id count

unsigned char **allow_url;	//Allow urls
unsigned int allow_url_count;	//Allow urls count

unsigned int sections_count;    //Count of sections in config



//SECTIONS OPTIONS

struct section
       {
	unsigned char *name;	//Header name
	char *ban_dir;	//Ban lists dir
	char *url;	//Url to change
	char log_flag;	//Write to log or not

	unsigned char **allow_ip; 	//Allow ip
	unsigned int  allow_ip_count;  	//Allow ip count

	unsigned char **allow_id;	//Allow id
	unsigned int  allow_id_count;	//Allow id count

       pcre **ban_pcre;	     		//Ban PCRE patterns
       pcre_extra **ban_pcre_s; 	//Ban PCRE optimization
       unsigned int ban_pcre_count;     //Ban PCRE patterns count        

       unsigned char **ban_urls;	//Ban urls lists area
       unsigned int *ban_urls_start;	//Pointers to start of url list for N domen level
       unsigned int *ban_urls_count;	//Counter of list elements for N domen level
       unsigned int ban_urls_end;	//Counter of ban_urls_start and _count
     } **redir;

char *now (void);
int check_id(unsigned char **,unsigned int);
int check_ip(unsigned char **,unsigned int );
unsigned int check_allow_url(void);
void err_mes(char*);
void get_opt(char*);
void init_vars(void);
int parse_input(unsigned char *);
int check_pcre(int);
void reverse(unsigned char **,unsigned int);
unsigned int check_url(int);
void sort_id(unsigned char **,unsigned int);
void load_pcre_file(int);
void load_pcre_urls(int);
void prepare_allow_url(void);
void load_urls_file(int);
void init_antivir_plugin(void);
char* ask_antivir_plugin(void);

